/**
 * moon.java -- Describes a moon, and also a set of moons
 *
 * By Bob Jenkins, July 1998
 * Permission granted to use, reuse, rewrite this without notifying me.
 */

import java.awt.*;
import java.lang.Math;
import java.util.*;

// An object.  It has mass, position, and velocity.
public final class moon {
  point  a;     // acceleration (0) and its differentials
  point  v;     // current velocity
  point  p;     // current location
  double m;     // mass
  Color  c;     // color

  double r;     // radius
  int screenx;  // x coordinate on screen
  int screeny;  // y coordinate on screen
  int screenr;  // radius on screen
  point peye;   // point as translated by the eye
  public moon  other[];  // other moons this moon interacts with

  // p(x,y,z) v(x,y,z) mass color size
  // example, "p(0.0,0.0,0.0) v(0.0,0.0,0.0) 1.0 ff00ff 1.0"
  public moon(String s) {
    StringTokenizer st = new StringTokenizer(s, " pv(,)");
    point  p = new point(0.0, 0.0, 0.0);
    point  v = new point(0.0, 0.0, 0.0);  

    p.x = point.s2d(st.nextToken(), 0.0);
    p.y = point.s2d(st.nextToken(), 0.0);
    p.z = point.s2d(st.nextToken(), 0.0);
    v.x = point.s2d(st.nextToken(), 0.0);
    v.y = point.s2d(st.nextToken(), 0.0);
    v.z = point.s2d(st.nextToken(), 0.0);
    double mass = point.s2d(st.nextToken(), 0.0);
    Color  c = point.s2c(st.nextToken(), Color.white);
    double planetsize = point.s2d(st.nextToken(), 0.0);
    setmoon(p,v,mass,c,planetsize);
  }

  public moon(point  p,    // position
	      point  v,    // velocity
	      double m,    // mass
	      Color  c,    // color
	      double r)    // radius
  { setmoon(p,v,m,c,r); }

  void setmoon(point p, point v, double m, Color c, double r) {
    this.a = new point(0.0, 0.0, 0.0);
    this.v = new point(v.x, v.y, v.z);
    this.p = new point(p.x, p.y, p.z);
    this.m = m;
    this.r = r;
    this.c = c;

    this.peye = new point(0.0, 0.0, 0.0);
  }
}



